<script lang="ts">
import { UseLiteVimeo, UseLocalizedVideoSubtitles } from '~/mixins';

export default {
  mixins: [UseLiteVimeo, UseLocalizedVideoSubtitles],
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
};
</script>

<template>
  <SlpContainer
    class="slp-mb-96"
    :class="{ 'full-background': data.full_background }"
    :data-aos="data.aos_animation"
    :data-aos-duration="data.aos_duration"
  >
    <SlpRow class="slp-pt-32">
      <SlpColumn class="slp-flex slp-flex-column">
        <SlpIcon
          v-if="data.header_icon"
          class="slp-mb-8"
          :name="data.header_icon.name"
          :variant="data.header_icon.variant"
          :alt="data.header_icon.alt"
          size="xl"
        />
        <SlpTypography
          v-if="data.header"
          tag="h2"
          variant="heading3-bold"
          class="header"
        >
          {{ data.header }}
        </SlpTypography>
        <SlpTypography
          v-if="data.subtitle"
          tag="h3"
          variant="heading4"
          class="subtitle"
          >{{ data.subtitle }}
        </SlpTypography>
        <div
          v-if="data.description"
          class="description__main"
          v-html="$md.render(data.description)"
        ></div>
      </SlpColumn>
    </SlpRow>
    <SlpRow
      :class="{ grid: data.cards_per_row }"
      :style="{ 'grid-template-columns': `repeat(${data.cards_per_row}, 1fr` }"
    >
      <a
        v-for="benefit in data.benefits"
        :key="benefit.title"
        class="benefit-link-card"
        :class="{ 'benefit-link-card--no-clickable': !benefit.link }"
        :data-ga-name="benefit.link ? benefit.link.data_ga_name : null"
        :data-ga-location="benefit.link ? benefit.link.data_ga_location : null"
        :href="benefit.link ? benefit.link.url : null"
      >
        <SlpColumn class="card" :class="data.text_align">
          <SlpIcon
            v-if="benefit.icon"
            class="icon"
            :name="benefit.icon.name"
            :alt="benefit.icon.alt"
            :variant="benefit.icon.variant"
            size="md"
            :hex-color="benefit.icon.hex_color"
          />
          <img
            v-else-if="benefit.no_slippers_icon"
            class="icon"
            :src="benefit.no_slippers_icon"
            alt=""
            loading="lazy"
          />
          <SlpTypography tag="h3" variant="heading5-bold" class="title">{{
            benefit.title
          }}</SlpTypography>
          <div
            v-if="benefit.description"
            class="description"
            v-html="$md.render(benefit.description)"
          ></div>
          <lite-vimeo
            v-if="benefit.video"
            :videoid="
              getVimeoVideoId(createVideoSource(benefit.video.video_url))
            "
            autoplay
          ></lite-vimeo>
          <SlpButton
            v-if="benefit.link"
            variant="tertiary"
            class="card__link"
            :href="benefit.link.url"
            :data-ga-name="benefit.link.data_ga_name"
            :data-ga-location="benefit.link.data_ga_location"
          >
            <SlpTypography variant="body1">
              {{ benefit.link.text }}
            </SlpTypography>
            <SlpIcon name="chevron-right" variant="product" />
          </SlpButton>
        </SlpColumn>
      </a>
    </SlpRow>
  </SlpContainer>
</template>

<style lang="scss" scoped>
$video-height: 315px;

section {
  position: relative;
}

.benefit-link-card {
  text-decoration: none;
  color: inherit;
}

.full-background {
  background-color: $color-surface-800;
  margin: 0 calc(50% - 50vw) $spacing-96 calc(50% - 50vw);
  box-sizing: border-box;
  padding: 0 calc(50vw - 50%) $spacing-48;
}

.header {
  margin: $spacing-96 0 1rem 0;
}

.description {
  line-height: 24px;
  font-size: 16px;
  margin-bottom: $spacing-32;

  &:deep ul {
    list-style: unset;
    padding-left: 1rem;
    margin-top: $spacing-16;

    @media (min-width: $breakpoint-sm) {
      padding: revert;
    }
  }

  &__main {
    text-align: left;
  }

  p {
    text-decoration: none !important;
  }
}

a:hover {
  .description {
    p {
      text-decoration: none;
    }
  }
}

.subtitle {
  font-size: 24px;
  line-height: 30px;
  text-align: left;

  @media (min-width: $breakpoint-md) {
    width: 66%;
  }
}

.card {
  display: flex;
  width: 543px;
  padding: 24px;
  flex-direction: column;
  align-items: flex-start;
  gap: 16px;
  margin-right: $spacing-32;
  height: 100%;
  width: 100%;
  border-radius: 4px;
  background: var(--slp-color-surface-50, #fff);

  &__link {
    margin-top: auto;

    &:hover {
      text-decoration: underline;
    }
  }

  .title {
    margin-bottom: $spacing-16;
  }

  .icon {
    max-height: 35px;
    max-width: 48px;
  }

  lite-vimeo {
    height: calc(#{$video-height} / 2);
    width: 100%;

    @media (min-width: $breakpoint-sm) {
      height: $video-height;
    }
  }

  &.left {
    text-align: left;
  }
}

.grid {
  display: grid !important;
  gap: 24px;
  margin: $spacing-48 auto 0 auto;
  max-width: 100%;
  @media (max-width: $breakpoint-lg) {
    // using important as the grid template columns property is being set as an inline style in the template above
    // in order to support card number per row config through the yml file.
    grid-template-columns: 1fr !important;
  }
}
</style>
